org.apache.tinkerpop.gremlin.process.computer.traversal.step.map

## Class PageRankVertexProgramStep

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<ComputerResult,ComputerResult>
  - - org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.VertexProgramStep
    - - org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.PageRankVertexProgramStep

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<ComputerResult>>, VertexComputing, Step<ComputerResult,ComputerResult>, ByModulating, TimesModulating, TraversalParent

      public final class PageRankVertexProgramStep
      extends VertexProgramStep
      implements TraversalParent, ByModulating, TimesModulating

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.VertexProgramStep

      `computer, first, ROOT_TRAVERSAL, STEP_ID`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PageRankVertexProgramStep(Traversal.Admin traversal, double alpha)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `PageRankVertexProgramStep` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `PageRankVertexProgram` | `generateProgram(Graph graph, Memory memory)` Generate the `VertexProgram`.
    `List<Traversal.Admin<Vertex,Edge>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `void` | `modulateBy(String pageRankProperty)`
    `void` | `modulateBy(Traversal.Admin<?,?> edgeTraversal)`
    `void` | `modulateTimes(int times)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.computer.traversal.step.map.VertexProgramStep

      `getComputer, isEndStep, previousTraversalVertexProgram, processNextStart, setComputer`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getTraversal, hasNext, next, removeLabel, reset, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.traversal.step.VertexComputing

      `generateComputer`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### PageRankVertexProgramStep

          public PageRankVertexProgramStep(Traversal.Admin traversal,
                                           double alpha)

  - ### Method Detail

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> edgeTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### modulateBy

          public void modulateBy(String pageRankProperty)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### modulateTimes

          public void modulateTimes(int times)

      Specified by:
        `modulateTimes` in interface `TimesModulating`

    - #### getLocalChildren

          public List<Traversal.Admin<Vertex,Edge>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<ComputerResult,ComputerResult>`

    - #### generateProgram

          public PageRankVertexProgram generateProgram(Graph graph,
                                                       Memory memory)

      Description copied from interface: `VertexComputing`
      Generate the `VertexProgram`.
      Specified by:
        `generateProgram` in interface `VertexComputing`
      Parameters:
        `graph` - the `Graph` that the program will be executed over.
        `memory` - the `Memory` from the previous OLAP job if it exists, else its an empty memory structure.
      Returns:
        the generated vertex program instance.

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<ComputerResult,ComputerResult>`
      Returns:
        the set of requirements

    - #### clone

          public PageRankVertexProgramStep clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when reset() is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<ComputerResult,ComputerResult>`
      Overrides:
        `clone` in class `AbstractStep<ComputerResult,ComputerResult>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<ComputerResult,ComputerResult>`
      Overrides:
        `setTraversal` in class `AbstractStep<ComputerResult,ComputerResult>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<ComputerResult,ComputerResult>`

Copyright © 2013–2019 Apache Software Foundation. All rights reserved.